package com.gavin.rule;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.yindangu.v3.business.plugin.business.api.rule.IRule;
import com.yindangu.v3.business.plugin.business.api.rule.IRuleContext;
import com.yindangu.v3.business.plugin.business.api.rule.IRuleOutputVo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author huangjr
 * @since 2021-05-28
 */
public class GavinTestRule implements IRule {

    private static final Logger logger = LoggerFactory.getLogger(GavinTestRule.class);

    public static String TEST_STRING = "test_string";
    public static String TEST_NUMBER = "test_number";
    public static String TEST_ENTITY = "test_entity";
    public static String TEST_ENTITY_FIELD_ONE = "test_field_one";
    public static String TEST_ENTITY_FIELD_TWO = "test_field_two";
    public static String TEST_ENTITY_FIELD_THREE = "test_field three";

    public static String TEST_OUTPARAM_ONE = "test_outparam_one";
    public static String TEST_OUTPARAM_TWO = "test_outparam_two";
    public static String TEST_OUTPARAM_THREE = "test_outparam_three";

    public static String TEST_OUTPARAM_ENTITY = "test_outparam_entity";
    public static String TEST_OUTPARAM_ENTITY_FIELD_ONE = "test_outparam_entity_field_one";


    @Override
    public IRuleOutputVo evaluate(IRuleContext ruleContext) {
        String testString = (String) ruleContext.getInput(TEST_STRING);
        Number number = (Number) ruleContext.getInput(TEST_NUMBER);
        
        List<Map<String, Object>> entity = (List<Map<String, Object>>) ruleContext.getInput(TEST_ENTITY);

        //  读取规则输入变量
        logger.info("参数" + TEST_STRING + "的值为:" + testString);
        logger.info("参数" + TEST_NUMBER + "的值为:" + number);

        int index = 0;
        String mapOneVal = "";
        String mapTwoVal = "";
        String mapThreeVal = "";
        List<Map<String, String>> outputEntity = new ArrayList<Map<String, String>>();

        for (Map<String, Object> record : entity) {
            String one = (String) record.get(TEST_ENTITY_FIELD_ONE);
            String two = (String) record.get(TEST_ENTITY_FIELD_TWO);
            String three = (String) record.get(TEST_ENTITY_FIELD_THREE);
            
            if (index != 0) {
                mapOneVal += ",";
                mapTwoVal += ",";
                mapThreeVal += ",";    
            }

            mapOneVal += one;
            mapTwoVal += two;
            mapThreeVal += three;

            String outparamEntityFieldOneVal = one + "," + two + "," + three;

            logger.info("...>>>开始获取实体的第" + index + "行记录<<<...");
            logger.info("实体第1列的值为:" + TEST_ENTITY_FIELD_ONE + " = " + one);
            logger.info("实体第2列的值为:" + TEST_ENTITY_FIELD_TWO + " = " + two);
            logger.info("实体第3列的值为:" + TEST_ENTITY_FIELD_THREE + " = " + three);
            logger.info("...>>>结束获取实体的第" + index +"行记录<<<...");

            Map<String, String> outputEntityRecord = new HashMap<String, String>();
            outputEntityRecord.put(TEST_OUTPARAM_ENTITY_FIELD_ONE, outparamEntityFieldOneVal);

            outputEntity.add(outputEntityRecord);

            index++;
        }        

        //  赋值到规则输出
        IRuleOutputVo outputParam = ruleContext.newOutputVo();
        outputParam.put(TEST_OUTPARAM_ONE, mapOneVal);
        outputParam.put(TEST_OUTPARAM_TWO, mapTwoVal);
        outputParam.put(TEST_OUTPARAM_THREE, mapThreeVal);
        outputParam.put(TEST_OUTPARAM_ENTITY, outputEntity);        

        return outputParam;
    }
    
}